/*̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief FAT12/16/32޽
 *
 * ̧قAVR32޲łFATp֐̗Lpȑg`܂B
 *
 * \author	Atmel Corporation	: http://www.atmel.com \n
 *			xFAQ			: http://support.atmel.no/
 *
 *****************************************************************************/

/* 쌠 (c) 2006-2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________
#include "conf_explorer.h"
#include "file.h"
#include "navigation.h"
#include LIB_MEM
#include LIB_CTRLACCESS

//_____ 錾 _______________________________________________________________

//! ̧ق羸i[̂"FAT "gp(file_putc(), file_getc(), file_read_buf(), file_write_buf()B)
#if __GNUC__ && __AVR32__
__attribute__((__aligned__(4)))
#elif __ICCAVR32__
#pragma data_alignment = 4
#endif
extern _MEM_TYPE_SLOW_ U8 fs_g_sector[ FS_CACHE_SIZE ];

static void file_load_segment_value( Fs_file_segment _MEM_TYPE_SLOW_ *segment );

//! ̊֐̧قIĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	̧ق͑IĂ܂B
//! @return	FALSE	̑
//!
Bool file_ispresent (void)
{
	if( !fat_check_mount_select() )
		return FALSE;
	return fat_check_is_file();
}

//! ̊֐͑I̧قJ܂B
//!
//! @param	fopen_mode	̧قJ߂̔CӑI<br>
//!						FOPEN_MODE_R		R  , ߲=0, eʕύXȂ<br>
//!						FOPEN_MODE_R_PLUS	R/W, ߲=0, eʕύXȂ<br>
//!						FOPEN_MODE_W		W  , ߲=0, e=0<br>
//!						FOPEN_MODE_W_PLUS	R/W, ߲=0, e=0<br>
//!						FOPEN_MODE_APPEND	W  , ߲=Ō, eʕύXȂ<br>
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
Bool file_open (U8 fopen_mode)
{
	if( !fat_check_mount_select_noopen())
		return FALSE;

	if( !fat_check_is_file())
		return FALSE;

	if(FOPEN_WRITE_ACCESS & fopen_mode)
	{
		if( !fat_check_nav_access_file( TRUE ) )
			return FALSE;
#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
		if (FS_ATTR_READ_ONLY & fs_g_nav_entry.u8_attr)
		{
			fs_g_status = FS_ERR_READ_ONLY;	// ̧ق͓ǂݍݐp
			return FALSE;
		}
		if( mem_wr_protect( fs_g_nav.u8_lun  ))
		{
			fs_g_status = FS_LUN_WP;		// ިǂݍݐp
			return FALSE;
		}
#else
		fs_g_status = FS_ERR_MODE_NOAVIALABLE;
		return FALSE;
#endif // FS_LEVEL_FEATURES
	}
	else
	{
		if( !fat_check_nav_access_file( FALSE ) )
			return FALSE;
	}

	if(FOPEN_CLEAR_SIZE & fopen_mode)
	{
		fs_g_nav_entry.u32_size = 0;		// eʂ0
	}
	if(FOPEN_CLEAR_PTR & fopen_mode)
	{
		fs_g_nav_entry.u32_pos_in_file = 0;
	}
	else
	{	// ̧ق̍Ō֍sB
		fs_g_nav_entry.u32_pos_in_file = fs_g_nav_entry.u32_size;
	}
	fs_g_nav_entry.u8_open_mode = fopen_mode;
	return TRUE;
}

//! ̊֐͑̕ϐɑS澸ĕϐi[܂B
//!
//! @param	segment	ϐ߲
//!
static void file_load_segment_value (Fs_file_segment _MEM_TYPE_SLOW_ *segment)
{
	segment->u8_lun = fs_g_nav.u8_lun;
	segment->u32_addr = fs_g_seg.u32_addr;
	segment->u16_size = fs_g_seg.u32_size_or_pos;
}

//! ̊֐̧قɑΉ镨ؓ̾(ʒuƗe)Ԃ܂B
//!
//! @param	segment	č\߲̂<br>
//!					->u32_size_or_pos	IN	̧ٓǂނ߂̍ő徸܂݂܂(0=)B<br>
//!					->u32_size_or_pos	OUT	(Pʂ)ėeʂ܂݂܂B<br>
//!					->̑			IN	܂B<br>
//!					->̑			OUT	Ĉʒu܂݂܂B<br>
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
//! @verbatim
//! ٰ݂DMAoŖقǂނ̂ɏdvŁAٰ̧݂ яȂŕ
//! I ĂԂ߁A̧ т̕܂B
//! :̧ق͒fЉ꓾AefЉɑ΂file_read()Ă΂Ȃ΂Ȃ܂B
//! @endverbatim
//!
Bool file_read (Fs_file_segment _MEM_TYPE_SLOW_ *segment)
{
	U8 u8_nb_sector_truncated;

	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_READ_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_WRITE_ONLY;
		return FALSE;
	}

	if ( file_eof() )
	{
		// ُ̧I
		fs_g_status = FS_ERR_EOF;
		return FALSE;
	}

	if( !fat_read_file(FS_CLUST_ACT_SEG))
	{
		if( FS_ERR_OUT_LIST == fs_g_status )
			fs_g_status = FS_ERR_EOF;		// ُϊ
		return FALSE;
	}
	// Ă傫ꍇAϊ
	if( (segment->u16_size != 0)			// ȂȂAϊȂ
	 && (segment->u16_size < fs_g_seg.u32_size_or_pos) )
	{
		u8_nb_sector_truncated   = fs_g_seg.u32_size_or_pos - segment->u16_size;
		fs_g_seg.u32_size_or_pos = segment->u16_size ;
	}else{
		u8_nb_sector_truncated = 0;
	}

	// ̧وʒuXV
	fs_g_nav_entry.u32_pos_in_file += (U32)fs_g_seg.u32_size_or_pos * FS_512B;
	if( fs_g_nav_entry.u32_size < fs_g_nav_entry.u32_pos_in_file )
	{
		// Ă̧قƑ傫
		// \ȏꍇ:̧قSĂ̸׽ԂgpȂꍇA̧ ׽ꗗ̍Ō̸׽ŎgpȂvZ
		U8 u8_nb_sector_not_used;

		// Ō̾Ŏgp龸vZ
		// :܂A׽eʂ64K޲Ă傫łȂ߁Aŏ2޲Ă̑傫gp܂B
		u8_nb_sector_not_used = LSB1( fs_g_nav_entry.u32_size ) >> (FS_512B_SHIFT_BIT-8);
		if( 0 != (fs_g_nav_entry.u32_size & FS_512B_MASK) )
		{	// ̧ق̍Ō̾tłȂA͓ǂ܂Ȃ΂Ȃ܂B
			u8_nb_sector_not_used++;
		}

		// Ō̸׽ŎgpȂvZ
		u8_nb_sector_not_used = fs_g_nav.u8_BPB_SecPerClus - (u8_nb_sector_not_used % fs_g_nav.u8_BPB_SecPerClus);
		// ׽̑SgpȂȂA͕s
		if( u8_nb_sector_not_used == fs_g_nav.u8_BPB_SecPerClus )
			u8_nb_sector_not_used = 0;		// ̧ق͍Ō̸׽ԑSgp

		// ̒ļوʒuƾėeʂ猸Z
		u8_nb_sector_not_used -= u8_nb_sector_truncated;
		fs_g_seg.u32_size_or_pos -= u8_nb_sector_not_used;	// P
		fs_g_nav_entry.u32_pos_in_file -= ((U16)u8_nb_sector_not_used) << FS_512B_SHIFT_BIT;	// ޲ĒP
	}
	file_load_segment_value( segment );
	return TRUE;
}

//! ̊֐݈͌ʒuɑΉ̧ ްɏՕɕʂ܂B
//!
//! @param	buffer			ɏՕ
//! @param	u16_buf_size	ɏՕe
//!
//! @return	ǂ޲Đ
//! @return	0,ُ̏ꍇ
//!
U16 file_read_buf (U8 _MEM_TYPE_SLOW_ *buffer, U16 u16_buf_size)
{
	_MEM_TYPE_FAST_ U16 u16_nb_read_tmp;
	_MEM_TYPE_FAST_ U16 u16_nb_read;
	_MEM_TYPE_FAST_ U16 u16_pos_in_sector;
	_MEM_TYPE_FAST_ U32 u32_byte_remaining;

	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_READ_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_WRITE_ONLY;
		return FALSE;
	}

	u16_nb_read = 0;

	while( 0 != u16_buf_size )
	{
		if ( file_eof() )
		{
			fs_g_status = FS_ERR_EOF;
			return u16_nb_read;				// ُ̧I
		}
		u32_byte_remaining = fs_g_nav_entry.u32_size-fs_g_nav_entry.u32_pos_in_file;
		u16_pos_in_sector = fs_g_nav_entry.u32_pos_in_file % FS_512B;

		if( (0== u16_pos_in_sector)
		 && (FS_512B <= u32_byte_remaining)
		 && (FS_512B <= u16_buf_size)
#if __GNUC__ && __AVR32__ || __ICCAVR32__
		 && (Test_align((U32)buffer, sizeof(U32)))
#endif
		 )
		{
			// ̧ ް ؂ɏՕ֒ړ]ł܂(gp)B
			if( u16_buf_size <= u32_byte_remaining)
			{
				u16_nb_read_tmp = u16_buf_size;
			}else{
				u16_nb_read_tmp = u32_byte_remaining;
			}
			u16_nb_read_tmp = u16_nb_read_tmp / FS_512B;	// ]eʓǂݍ

			// 㑱̧ق̾ 擾
			if( !fat_read_file(FS_CLUST_ACT_SEG))
			{
				if( FS_ERR_OUT_LIST == fs_g_status )
					fs_g_status = FS_ERR_EOF;	// ُϊ
				return u16_nb_read;
			}
			// ꂽeʂ傫Όėeʂ؂l߂B
			if( u16_nb_read_tmp > fs_g_seg.u32_size_or_pos )
			{
				u16_nb_read_tmp = fs_g_seg.u32_size_or_pos;
			}else{
				fs_g_seg.u32_size_or_pos = u16_nb_read_tmp;
			}

			// ؂ɏՕ֒ް]
			while( 0 != fs_g_seg.u32_size_or_pos )
			{
				if( CTRL_GOOD != memory_2_ram( fs_g_nav.u8_lun  , fs_g_seg.u32_addr, buffer))
				{
					fs_g_status = FS_ERR_HW;
					return u16_nb_read;
				}
				fs_g_seg.u32_size_or_pos--;
				fs_g_seg.u32_addr++;
				buffer += FS_512B;
			}
			// Pʂ޲ĒPʂ֕ϊ
			u16_nb_read_tmp *= FS_512B;
		}
		else
		{
			// ̧ ް؂ɏՕ֒ړ]łAgpȂ΂Ȃ܂B

			// ؂ް]
			if( !fat_read_file( FS_CLUST_ACT_ONE ))
			{
				if( FS_ERR_OUT_LIST == fs_g_status )
				{	// ُϊ
					fs_g_status = FS_ERR_EOF;	// ُ̧I
				}
				return u16_nb_read;
			}

			// ]ްvZ
			u16_nb_read_tmp = FS_512B - u16_pos_in_sector;	// l;eʂŐ܂B
			if( u16_nb_read_tmp > u32_byte_remaining )
				u16_nb_read_tmp = u32_byte_remaining;
			if( u16_nb_read_tmp > u16_buf_size )
				u16_nb_read_tmp = u16_buf_size;

			// ɏՕް]
			memcpy_ram2ram( buffer , &fs_g_sector[ u16_pos_in_sector ], u16_nb_read_tmp );
			buffer += u16_nb_read_tmp;
		}
		// ʒuXV
		fs_g_nav_entry.u32_pos_in_file += u16_nb_read_tmp;
		u16_nb_read                    += u16_nb_read_tmp;
		u16_buf_size                   -= u16_nb_read_tmp;
	}
	return u16_nb_read;						// ɏՕt
}

//! ̊֐̧ق̎޲ĂԂ܂B
//!
//! @return	ǂ܂ꂽ޲
//! @return	EOF, ُ̏ꍇ܂̧ق̍Ō
//!
U16 file_getc (void)
{
	U16 u16_byte;

	while(1)
	{
		if(!(FOPEN_READ_ACCESS & fs_g_nav_entry.u8_open_mode))
		{
			fs_g_status = FS_ERR_WRITE_ONLY;
			break;
		}
		if( fs_g_nav_entry.u32_size <= fs_g_nav_entry.u32_pos_in_file )
		{
			fs_g_status = FS_ERR_EOF;
			break;
		}

		if( !fat_read_file( FS_CLUST_ACT_ONE ))
		{
			if( FS_ERR_OUT_LIST == fs_g_status )
			{	// ُϊ
				fs_g_status = FS_ERR_EOF;	// ُ̧I
			}
			break;
		}

		u16_byte = fs_g_sector[ fs_g_nav_entry.u32_pos_in_file & FS_512B_MASK ];
		fs_g_nav_entry.u32_pos_in_file++;
		return u16_byte;
	}
	return FS_EOF;							// ǂ܂ꂽްȂ
}

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐̧قɑΉ镨ؓ̾(ʒuƗe)蓖ĂĂԂ܂B
//!
//! @param	segment	č\߲̂<br>
//!					->u32_size_or_pos	IN, ̧قɏő徸܂݂܂B<br>
//!					->u32_size_or_pos	OUT,(Pʂ)ėeʂ܂݂܂B<br>
//!					->̑			IN, ܂B<br>
//!					->̑			OUT,Ĉʒu܂݂܂B<br>
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! ٰ݂DMAoRłُ̧݂ɏdvŁAٰ̧݂ яȂŕ
//!  ĂԂ߁A̧ т̕܂B
//! :̧ق͒fЉ꓾AefЉɑ΂file_write()Ă΂Ȃ΂Ȃ܂B
//! @endverbatim
//!
Bool file_write (Fs_file_segment _MEM_TYPE_SLOW_ *segment)
{
	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_WRITE_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_READ_ONLY;
		return FALSE;
	}

	if( !fat_write_file( FS_CLUST_ACT_SEG , segment->u16_size ))
		return FALSE;

	// Ă傫ꍇA؂l߂܂B
	if( (segment->u16_size != 0)			// x`Ă΁A
	 && (segment->u16_size < fs_g_seg.u32_size_or_pos) )
	{
		fs_g_seg.u32_size_or_pos = segment->u16_size ;
	}

	// ̧وʒuXV
	fs_g_nav_entry.u32_pos_in_file += ((U32)fs_g_seg.u32_size_or_pos * FS_512B);

	// ̧ٗeʍXV
	if( fs_g_nav_entry.u32_pos_in_file > fs_g_nav_entry.u32_size )
	{
		fs_g_nav_entry.u32_size = fs_g_nav_entry.u32_pos_in_file;
	}
	file_load_segment_value( segment );
	return TRUE;
}

//! ̊֐݈͌ʒu̧ق̍Ōݒ肵܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! ٰ݂͒ʏlast file_write()ĂяoɎgp܂B
//! file_write()ٰ݂;P(512޲)gpAfile_seek()fiel_set_eof()̌Ăяo޲ėeʂw肷邱Ƃł܂B
//! @endverbatim
//!
Bool file_set_eof (void)
{
	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_WRITE_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_READ_ONLY;
		return FALSE;
	}

	// ̧ٗeʍXV
	fs_g_nav_entry.u32_size = fs_g_nav_entry.u32_pos_in_file;

	if( !fat_read_file( FS_CLUST_ACT_CLR ))
		return FALSE;

	return fat_cache_flush();
}

//! ̊֐̧݂͌وʒuŊɏՕ̧قɓ]܂B
//!
//! @param	buffer			ްɏՕ
//! @param	u16_buf_size	ްe
//!
//! @return	ꂽ޲Đ
//! @return	0, ُ̏ꍇ
//!
U16 file_write_buf (U8 _MEM_TYPE_SLOW_ *buffer, U16 u16_buf_size)
{
	_MEM_TYPE_FAST_ U16 u16_nb_write_tmp;
	_MEM_TYPE_FAST_ U16 u16_nb_write;
	_MEM_TYPE_FAST_ U16 u16_pos_in_sector;

	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_WRITE_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_READ_ONLY;
		return FALSE;
	}

	u16_nb_write = 0;

	while( 0 != u16_buf_size )
	{
		// ̧ ް ͊ɏՕ؂֒ړ]邱Ƃł܂(gp)B
		u16_pos_in_sector = fs_g_nav_entry.u32_pos_in_file % FS_512B;
	if( (0== u16_pos_in_sector)
		 && (FS_512B <= u16_buf_size)
#if __GNUC__ && __AVR32__ || __ICCAVR32__
		 && (Test_align((U32)buffer, sizeof(U32)))
#endif
		 )
		{
			u16_nb_write_tmp = u16_buf_size / FS_512B;	// ]eʓǂݍ

			// ̧ق̌㑱 擾AǊ蓖
			if( !fat_write_file( FS_CLUST_ACT_SEG , u16_nb_write_tmp ))
				return FALSE;
			// ꂽeʂ傫̧ Ă؂l
			if( u16_nb_write_tmp < fs_g_seg.u32_size_or_pos)
			{
				fs_g_seg.u32_size_or_pos = u16_nb_write_tmp;
			}else{
				u16_nb_write_tmp = fs_g_seg.u32_size_or_pos;
			}

			// ɏՕ؂֒ް]
			while( 0 != fs_g_seg.u32_size_or_pos )
			{
				if( CTRL_GOOD != ram_2_memory( fs_g_nav.u8_lun  , fs_g_seg.u32_addr, buffer))
				{
					fs_g_status = FS_ERR_HW;
					return u16_nb_write;
				}
				fs_g_seg.u32_size_or_pos--;
				fs_g_seg.u32_addr++;
				buffer += FS_512B;
			}
			// Pʂ޲ĒPʂ֕ϊ
			u16_nb_write_tmp *= FS_512B;
		}
		else
		{
			// ̧ ް͊ɏՕ؂֒ړ]łAgpȂ΂Ȃ܂B

			// ؂ް ]AǊ蓖
			if((fs_g_nav_entry.u32_pos_in_file == fs_g_nav_entry.u32_size)
			&& (0==u16_pos_in_sector) )
			{
				// ǁA̧قɑ΂1̐V蓖
				if( !fat_write_file( FS_CLUST_ACT_SEG  , 1 ))
					return FALSE;
				// XV
				fs_gu32_addrsector = fs_g_seg.u32_addr;
				if( !fat_cache_read_sector( FALSE ))	// ꂪVȂ̂ŁA؂͓ǂ܂܂B
					return FALSE;
				}else{
				// ݂͑Ȃ΂Ȃ炸A蓖Ă̕Kv͂܂B
				if( !fat_write_file( FS_CLUST_ACT_ONE  , 1 ))
					return FALSE;
			}

			// ύX׸ސݒ
			fat_cache_mark_sector_as_dirty();

			// ]ްvZ
			u16_nb_write_tmp = FS_512B - u16_pos_in_sector;		// l;eʂŐ܂B
			if( u16_nb_write_tmp > u16_buf_size )
				u16_nb_write_tmp = u16_buf_size;

			// ɏՕް]
			memcpy_ram2ram( &fs_g_sector[ u16_pos_in_sector ], buffer , u16_nb_write_tmp );
			buffer += u16_nb_write_tmp;
		}
		// ʒuXV
		fs_g_nav_entry.u32_pos_in_file += u16_nb_write_tmp;
		u16_nb_write                   += u16_nb_write_tmp;
		u16_buf_size                   -= u16_nb_write_tmp;
		// ̧ٗeʍXV
		if( fs_g_nav_entry.u32_pos_in_file > fs_g_nav_entry.u32_size )
		{
			fs_g_nav_entry.u32_size = fs_g_nav_entry.u32_pos_in_file;
		}
	}
	return u16_nb_write;					// SɏՕݍς
}

//! ̊֐̧ٓ޲Ă܂B
//!
//! @param	u8_byte	޲
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool file_putc (U8 u8_byte)
{
	if( !fat_check_mount_select_open())
		return FALSE;

	if(!(FOPEN_WRITE_ACCESS & fs_g_nav_entry.u8_open_mode))
	{
		fs_g_status = FS_ERR_READ_ONLY;
		return FALSE;
	}

	if( !fat_write_file( FS_CLUST_ACT_ONE  , 1 ))
		return FALSE;

	// ް֏B
	fat_cache_mark_sector_as_dirty();
	fs_g_sector[ fs_g_nav_entry.u32_pos_in_file & FS_512B_MASK ] = u8_byte;
	fs_g_nav_entry.u32_pos_in_file++;

	// ̧ٗeʍXV
	if( fs_g_nav_entry.u32_pos_in_file > fs_g_nav_entry.u32_size )
	{
		fs_g_nav_entry.u32_size = fs_g_nav_entry.u32_pos_in_file;
	}
	return TRUE;
}
#endif // FS_LEVEL_FEATURES

//! ̊֐̧ٓ̈ʒuԂ܂B
//!
//! @return	̧ٓʒu
//!
U32 file_getpos (void)
{
	if( !fat_check_mount_select_open() )
		return 0;

	return fs_g_nav_entry.u32_pos_in_file;
}

//! ̊֐̧ٓ̈ʒuύX܂B
//!
//! @param	u32_pos		s޲Đ
//! @param	u8_whence	s<br>
//!						FS_SEEK_SET		ِ̧擪AŊJn<br>
//!						FS_SEEK_END		ٍ̧ŌAtŊJn<br>
//!						FS_SEEK_CUR_RE	݈ʒuAtŊJn<br>
//!						FS_SEEK_CUR_FW	݈ʒuAŊJn<br>
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
Bool file_seek (U32 u32_pos, U8 u8_whence)
{
	if( !fat_check_mount_select_open())
		return FALSE;

	switch(u8_whence)
	{
		case FS_SEEK_CUR_RE:
			if( fs_g_nav_entry.u32_pos_in_file < u32_pos )
			{	// xO
				fs_g_status = FS_ERR_BAD_POS;
				return FALSE;
			}
			// ʒuXV
			fs_g_nav_entry.u32_pos_in_file -= u32_pos;
			break;

		case FS_SEEK_SET:
			if( fs_g_nav_entry.u32_size < u32_pos )
			{	// xO
				fs_g_status = FS_ERR_BAD_POS;
				return FALSE;
			}
			// ʒuXV
			fs_g_nav_entry.u32_pos_in_file = u32_pos;
			break;

		case FS_SEEK_END:
			if( fs_g_nav_entry.u32_size < u32_pos )
			{	// xO
				fs_g_status = FS_ERR_BAD_POS;
				return FALSE;
			}
			// ʒuXV
			fs_g_nav_entry.u32_pos_in_file = fs_g_nav_entry.u32_size - u32_pos;
			break;

		case FS_SEEK_CUR_FW:
			u32_pos += fs_g_nav_entry.u32_pos_in_file;
			if( fs_g_nav_entry.u32_size < u32_pos )
			{	// xO
				fs_g_status = FS_ERR_BAD_POS;
				return FALSE;
			}
			// ʒuXV
			fs_g_nav_entry.u32_pos_in_file = u32_pos;
			break;
	}
	return TRUE;
}

//! ̊֐̧ق̎n߂𒲂ׂ܂B
//!
//! @return	1		ʒu̧ق̐擪
//! @return	0		ʒuِ̧擪łȂB
//! @return	0xFF	ُ
//!
U8 file_bof (void)
{
	if( !fat_check_mount_select_open() )
		return 0xFF;

	return (0 == fs_g_nav_entry.u32_pos_in_file );
}

//! ̊֐̧ق̍Ō𒲂ׂ܂B
//!
//! @return	1		ʒu̧ق̍Ō
//! @return	0		ʒu̧ق̍Ōł͂ȂB
//! @return	0xFF	ُ
//!
U8 file_eof (void)
{
	if( !fat_check_mount_select_open() )
		return 0xFF;
	return (fs_g_nav_entry.u32_size <= fs_g_nav_entry.u32_pos_in_file );
}

//! ̊֐͓(̧ ްُ̧)j܂B
//!
void file_flush (void)
{
	U8 save_open_mode;
	save_open_mode = fs_g_nav_entry.u8_open_mode;
	file_close();
	fs_g_nav_entry.u8_open_mode = save_open_mode;
}

//! ̊֐̧ق܂B
//!
void file_close (void)
{
	// ̧قJĂꍇAB
	if( fat_check_mount_select_open() )
	{

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
		if( FOPEN_WRITE_ACCESS & fs_g_nav_entry.u8_open_mode )
		{
			// ُ̧񏑂
			if( !fat_read_dir() )
				return;						// ُ
			fat_write_entry_file();
			fat_cache_flush();				// ްݒُ̈̏ꍇA֐oOްj
		}
#endif // FS_LEVEL_FEATURES
		Fat_file_close();
	}
}
